Ruby: include/ruby/internal/arithmetic/intptr_t.h File Reference

Ruby 3.2.5p208 (2024-07-26 revision 31d0f1a2e7dbfb60731d1f05b868e1d578cda493)

Macros | Functions
intptr_t.h File Reference

Arithmetic conversion between C's `intptr_t` and Ruby's. More...

`#include "ruby/internal/config.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/internal/dllexport.h"`

Go to the source code of this file.

## Macros
#define | rb_int_new rb_int2inum
| Just another name of rb_int2inum.
#define | rb_uint_new rb_uint2inum
| Just another name of rb_uint2inum.

## Functions
VALUE | rb_int2big (intptr_t i)
| Converts a C's `intptr_t` into an instance of rb_cInteger.
VALUE | rb_int2inum (intptr_t i)
| Converts a C's `intptr_t` into an instance of rb_cInteger.
VALUE | rb_uint2big (uintptr_t i)
| Converts a C's `intptr_t` into an instance of rb_cInteger.
VALUE | rb_uint2inum (uintptr_t i)
| Converts a C's `uintptr_t` into an instance of rb_cInteger.

## Detailed Description

Arithmetic conversion between C's `intptr_t` and Ruby's.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file intptr_t.h.

## Macro Definition Documentation

## ◆ rb_int_new

#define rb_int_new rb_int2inum

Just another name of rb_int2inum.

Definition at line 32 of file intptr_t.h.

## ◆ rb_uint_new

#define rb_uint_new rb_uint2inum

Just another name of rb_uint2inum.

Definition at line 33 of file intptr_t.h.

## Function Documentation

## ◆ rb_int2big()

VALUE rb_int2big | ( | intptr_t | i | ) |

Converts a C's `intptr_t` into an instance of rb_cInteger.

Parameters

  [in] | i | Arbitrary `intptr_t` value.

Returns
  An instance of rb_cInteger.

Note
  This function always allocates Bignums, even if the given number is small enough to fit into a Fixnum.

Definition at line 3209 of file bignum.c.

## ◆ rb_int2inum()

VALUE rb_int2inum | ( | intptr_t | i | ) |

Converts a C's `intptr_t` into an instance of rb_cInteger.

Parameters

  [in] | i | Arbitrary `intptr_t` value.

Returns
  An instance of rb_cInteger.

Definition at line 3237 of file bignum.c.

## ◆ rb_uint2big()

VALUE rb_uint2big | ( | uintptr_t | i | ) |

Converts a C's `intptr_t` into an instance of rb_cInteger.

Parameters

  [in] | i | Arbitrary `intptr_t` value.

Returns
  An instance of rb_cInteger.

Note
  This function always allocates Bignums, even if the given number is small enough to fit into a Fixnum.

Definition at line 3187 of file bignum.c.

## ◆ rb_uint2inum()

VALUE rb_uint2inum | ( | uintptr_t | i | ) |

Converts a C's `uintptr_t` into an instance of rb_cInteger.

Parameters

  [in] | i | Arbitrary `uintptr_t` value.

Returns
  An instance of rb_cInteger.

Definition at line 3230 of file bignum.c.